## fcitx 4.1.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(fcitx)

set(version 4.1.1)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" OFF)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

FIND_PACKAGE(Gettext REQUIRED)
FIND_PACKAGE(Libintl REQUIRED)
FIND_PACKAGE(Libiconv REQUIRED)
FIND_PACKAGE(Pthread REQUIRED)
FIND_PACKAGE(Libexecinfo REQUIRED)
FIND_PACKAGE(DL REQUIRED)
FIND_PROGRAM(WGET wget)
FIND_PROGRAM(TAR tar)

FIND_PACKAGE(X11 REQUIRED)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib >= 1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo >= 1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1 >= 1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

set(_ENABLE_OPENCC 0)
if (ENABLE_OPENCC)
    PKG_CHECK_MODULES(OPENCC "opencc >= 0.1.1" )
    if (OPENCC_FOUND)
        set(_ENABLE_OPENCC 1)
    endif (OPENCC_FOUND)
endif (ENABLE_OPENCC)

if(ENABLE_DEBUG)
    set(_DEBUG)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${exec_prefix}/lib)
endif()

set(libdir ${LIB_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)
set(includedir  ${CMAKE_INSTALL_PREFIX}/include)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${isSystemDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
)

include_directories(${PROJECT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(cmake)

if (ENABLE_TEST)
    add_subdirectory(test)
endif (ENABLE_TEST)

=== data/CMakeLists.txt ===
if (ENABLE_TABLE)
    add_subdirectory(table)
endif (ENABLE_TABLE)

add_subdirectory(script)

set(FCITX_DESC_FILES
    addon.desc
    config.desc
    profile.desc
)

set(FCITX_DATA_FILES
    AutoEng.dat
    gbks2t.tab
    punc.mb
    vk.conf
)

set(FCITX_PY_FILES
    pySym.mb
    sp.dat
)

set(FCITX_DSEKTOP_FILES
    fcitx.desktop
    fcitx-kimpanel.desktop
    fcitx-configtool.desktop
)

set(PY_ORGDATA pyPhrase.org)
set(PY_DATA ${CMAKE_CURRENT_BINARY_DIR}/pybase.mb ${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb)
set(PY_TAR ${CMAKE_CURRENT_SOURCE_DIR}/pinyin.tar.gz)
set(PY_URL http://fcitx.googlecode.com/files/pinyin.tar.gz)


add_subdirectory(png)

intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx-configtool.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop )
intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx-kimpanel.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-kimpanel.desktop )
intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop )

add_custom_target(pinyin_data ALL DEPENDS ${PY_DATA})

add_custom_command(OUTPUT ${PY_ORGDATA}
                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/download.sh "${WGET}" "${PY_URL}" "${PY_TAR}"
                   COMMAND ${TAR} xzmvf ${PY_TAR})
add_custom_command(OUTPUT ${PY_DATA}
                   DEPENDS ${PY_ORGDATA}
                   COMMAND createPYMB ${CMAKE_CURRENT_SOURCE_DIR}/gbkpy.org ${CMAKE_CURRENT_BINARY_DIR}/${PY_ORGDATA})

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop DESTINATION share/applications/)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop DESTINATION share/applications/)
if (_ENABLE_DBUS)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-kimpanel.desktop DESTINATION share/applications/)
endif(_ENABLE_DBUS)

install(FILES ${FCITX_DATA_FILES} DESTINATION ${pkgdatadir}/data)
fcitx_add_configdesc_file(${FCITX_DESC_FILES})
install(FILES ${FCITX_PY_FILES} ${CMAKE_CURRENT_BINARY_DIR}/pybase.mb ${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb DESTINATION ${pkgdatadir}/pinyin)

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/pyERROR,${CMAKE_CURRENT_BINARY_DIR}/pyPhrase.ok")

=== po/CMakeLists.txt ===
set(PO_FILES zh_CN.po)
file(RELATIVE_PATH REL_SOURCE_ROOT ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})
if ("${REL_SOURCE_ROOT}" STREQUAL "")
    set(REL_SOURCE_ROOT ".")
endif("${REL_SOURCE_ROOT}" STREQUAL "")

set(POT_FILE fcitx.pot)

configure_file(POTFILES.in.in ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in)

extract_fcitx_addon_conf_postring()

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/desc.po
                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/getdescpo ${PROJECT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
                   DEPENDS getdescpo)

add_custom_target(
    pot
    COMMAND INTLTOOL_EXTRACT=${INTLTOOL_EXTRACT} srcdir=${CMAKE_CURRENT_BINARY_DIR} ${INTLTOOL_UPDATE} --gettext-package fcitx --pot
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/conf.po ${CMAKE_CURRENT_BINARY_DIR}/desc.po
    )

# Update .po files and compile them to binary .gmo files
gettext_create_translations(${POT_FILE} ALL ${PO_FILES})

=== src/frontend/gtk2/CMakeLists.txt ===
if(ENABLE_GTK2_IM_MODULE)

PKG_CHECK_MODULES(GTK2 REQUIRED "gtk+-2.0" )

_pkgconfig_invoke("gtk+-2.0" GTK2 BINARY_VERSION "" "--variable=gtk_binary_version")
set(GTK2_IM_MODULEDIR
 "${libdir}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules"
)

include_directories(${GTK2_INCLUDE_DIRS})
include_directories(${DBUS_GLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK2_LIBRARY_DIRS} ${DBUS_GLIB_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
)

set(FCITX_GTK2_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext.c
    client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(im-fcitx MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
set_target_properties( im-fcitx PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries( im-fcitx ${GTK2_LIBRARIES} ${DBUS_GLIB_LIBRARIES} fcitx-utils)

install(TARGETS im-fcitx DESTINATION ${GTK2_IM_MODULEDIR})

endif(ENABLE_GTK2_IM_MODULE)

=== src/frontend/gtk3/CMakeLists.txt ===
if(ENABLE_GTK3_IM_MODULE)

PKG_CHECK_MODULES(GTK3 REQUIRED "gtk+-3.0" )

_pkgconfig_invoke("gtk+-3.0" GTK3 BINARY_VERSION "" "--variable=gtk_binary_version")

set(GTK3_IM_MODULEDIR
 "${libdir}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules"
)

include_directories(${GTK3_INCLUDE_DIRS})
include_directories(${DBUS_GLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK3_LIBRARY_DIRS} ${DBUS_GLIB_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
)

set(FCITX_GTK3_IM_MODULE_SOURCES
    ../gtk2/fcitxim.c
    ../gtk2/fcitximcontext.c
    ../gtk2/client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(im-fcitx-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties( im-fcitx-gtk3 PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" OUTPUT_NAME "im-fcitx" LINK_FLAGS "-Wl,--no-undefined")

target_link_libraries( im-fcitx-gtk3 ${GTK3_LIBRARIES} ${DBUS_GLIB_LIBRARIES} fcitx-utils)

install(TARGETS im-fcitx-gtk3 DESTINATION ${GTK3_IM_MODULEDIR})

endif(ENABLE_GTK3_IM_MODULE)

=== src/frontend/xim/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/frontend/xim/lib)
include_directories(${X11_X11_INCLUDE_PATH})

set(fcitx_xim_SOURCES
    IC.c
    xim.c
    ximhandler.c
    ximconfig.c
)

set(Ximd_SOURCES
    lib/FrameMgr.c
    lib/i18nAttr.c
    lib/i18nClbk.c
    lib/i18nIc.c
    lib/i18nIMProto.c
    lib/i18nMethod.c
    lib/i18nPtHdr.c
    lib/i18nUtil.c
    lib/i18nX.c
    lib/IMConn.c
    lib/IMMethod.c
    lib/IMValues.c
)


fcitx_add_addon(fcitx-xim ${fcitx_xim_SOURCES} ${Ximd_SOURCES})
target_link_libraries( fcitx-xim ${X11_LIBRARIES})

fcitx_add_addon_conf_file(fcitx-xim.conf)
fcitx_add_configdesc_file(fcitx-xim.desc)

=== src/im/qw/CMakeLists.txt ===

set(FCITX_QUWEI_SOURCES
    qw.c
)

fcitx_add_addon(fcitx-qw ${FCITX_QUWEI_SOURCES})
fcitx_add_addon_conf_file(fcitx-qw.conf)

=== src/lib/fcitx-utils/CMakeLists.txt ===
set(FCITX_UTILS_SOURCES
    utf8.c
    utils.c
    log.c
    qsort_r.c
)

set(FCITX_UTILS_HEADERS
    log.h
    utarray.h
    utf8.h
    utils.h
    uthash.h
)

add_library(fcitx-utils SHARED ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils
                      PROPERTIES VERSION 0.1.0
                      SOVERSION 0.1
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)
target_link_libraries(fcitx-utils ${LIBINTL_LIBRARIES} ${LIBICONV_LIBRARIES})

configure_file(fcitx-utils.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc)

install(TARGETS fcitx-utils LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${includedir}/fcitx-utils")

if (ENABLE_STATIC)

add_library(fcitx-utils-static STATIC ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils-static PROPERTIES
    OUTPUT_NAME "fcitx-utils"
    PREFIX "lib"
)

install(TARGETS fcitx-utils-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== src/lib/fcitx/CMakeLists.txt ===
set(LIBFCITX_SOURCES
    candidate.c
    configfile.c
    profile.c
    addon.c
    frontend.c
    hook.c
    ime.c
    ui.c
    instance.c
    module.c
    keys.c
)

set(FCITX_HEADERS
    candidate.h
    ime.h
    ui.h
    hook.h
    configfile.h
    profile.h
    module.h
    instance.h
    addon.h
    frontend.h
    fcitx.h
    keys.h
)

link_directories(${DL_LIBRARY_DIRS} ${PTHREAD_LIBRARY_DIRS})

add_library(fcitx-core SHARED ${LIBFCITX_SOURCES})
set_target_properties(fcitx-core
                      PROPERTIES VERSION 0.1.0
                      SOVERSION 0.1
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)
target_link_libraries(fcitx-core fcitx-config)
configure_file(fcitx.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx.pc)

target_link_libraries(fcitx-core fcitx-config fcitx-utils ${DL_LIBRARIES} ${PTHREAD_LIBRARIES})
install(TARGETS fcitx-core LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_HEADERS} DESTINATION "${includedir}/fcitx")

if (ENABLE_STATIC)

add_library(fcitx-core-static STATIC ${LIBFCITX_SOURCES})
set_target_properties(fcitx-core-static PROPERTIES
    OUTPUT_NAME "fcitx-core"
    PREFIX "lib"
)

install(TARGETS fcitx-core-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== src/module/chttrans/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)

if (_ENABLE_OPENCC)
    include_directories(${OPENCC_INCLUDE_DIRS})
endif (_ENABLE_OPENCC)

set(FCITX_CHTTRANS_SOURCES
    chttrans.c
)

fcitx_add_addon(fcitx-chttrans ${FCITX_CHTTRANS_SOURCES})

if (_ENABLE_OPENCC)
    target_link_libraries( fcitx-chttrans ${OPENCC_LIBRARIES} )
    include_directories(${OPENCC_INCLUDE_DIRS})
endif (_ENABLE_OPENCC)

fcitx_add_configdesc_file(fcitx-chttrans.desc)
fcitx_add_addon_conf_file(fcitx-chttrans.conf)

=== src/module/quickphrase/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)

set(FCITX_QUICKPHRASE_SOURCES
    QuickPhrase.c
)

fcitx_add_addon(fcitx-quickphrase ${FCITX_QUICKPHRASE_SOURCES})
fcitx_add_addon_conf_file(fcitx-quickphrase.conf)

=== src/ui/classic/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${CAIRO_XLIB_INCLUDE_DIRS})
link_directories(${CAIRO_XLIB_LIBRARY_DIRS})

if (_ENABLE_PANGO)
    include_directories ( ${PANGOCAIRO_INCLUDE_DIRS} )
    link_directories(${PANGOCAIRO_LIBRARY_DIRS})
else (_ENABLE_PANGO)
    include_directories ( ${FONTCONFIG_INCLUDE_DIRS} )
    link_directories(${FONTCONFIG_LIBRARY_DIRS})
endif (_ENABLE_PANGO)

set(fcitx_classic_ui_SOURCES
    classicui.c
    classicuiconfig.c
    InputWindow.c
    MainWindow.c
    MenuWindow.c
    MessageWindow.c
    AboutWindow.c
    TrayWindow.c
    tray.c
    skinconfig.c
    skin.c
    ../cairostuff/font.c
    ../cairostuff/cairostuff.c
)

set(CLASSICUI_DESC_FILES
    fcitx-classic-ui.desc
    skin.desc
)

fcitx_add_addon(fcitx-classic-ui ${fcitx_classic_ui_SOURCES})
target_link_libraries( fcitx-classic-ui ${X11_LIBRARIES} ${CAIRO_XLIB_LIBRARIES} )

if (_ENABLE_PANGO)
    target_link_libraries( fcitx-classic-ui ${PANGOCAIRO_LIBRARIES} )
else (_ENABLE_PANGO)
    target_link_libraries( fcitx-classic-ui ${FONTCONFIG_LIBRARIES} )
endif (_ENABLE_PANGO)
fcitx_add_addon_header(classicui classicuiinterface.h)
fcitx_add_addon_conf_file(fcitx-classic-ui.conf)
fcitx_add_configdesc_file(${CLASSICUI_DESC_FILES})

## fcitx 3.6.3

=== debian/changelog ===
fcitx (1:3.6.3-1) unstable; urgency=low

  * new upstream release.
  * change to 3.0 (quilt) format.
  * debian/control:
    - bump standards version to 3.8.4.
    - build depends on debhelper > 7.0.50~
  * debian/patches/binutils-gold.patch: Fix "FTBFS with binutils-gold"
    (Closes: #554282)
  * debian/rules: run autoreconf before configure
  * debian/clean: updated.

 -- LI Daobing <lidaobing@debian.org>  Mon, 22 Feb 2010 21:00:56 +0800

fcitx (1:3.6.2-1) unstable; urgency=low

  * new upstream release.

 -- LI Daobing <lidaobing@debian.org>  Fri, 09 Oct 2009 19:29:06 +0800

fcitx (1:3.6.1-1) unstable; urgency=low

  * new upstream release.
  * debian/control:
    - add me to Uploader.
    - add libxtst-dev to Build-Depends.
    - bump standards version to 3.8.3.
  * debian/rules:
    - updated, no longer need to call autogen.sh
  * debian/clean: updated.

 -- LI Daobing <lidaobing@debian.org>  Thu, 24 Sep 2009 23:03:16 +0800

fcitx (1:3.6.0~rc-0.1) unstable; urgency=low

  * Non-maintainer upload (with the bless of the origin maintainer).
  * new upstream release.
  * debian/watch: rewrite.
  * debian/control:
    - bump standards version to 3.8.1.
    - bump debhelper version to 7.
    - add ${misc:Depends} to depends.
    - add automake and autoconf to build-depends.
  * debian/compat:
    - bump debhelper version to 7.
  * debian/fcitx.lintian-overrides: added.
  * debian/source.lintian-overrides: added. 
  * debian/rules: rewrite with debhelper 7.
  * debian/clean: added. 
  * debian/fcitx.install: added, install im-switch.
  * debian/dirs: remove usr/share/fcitx/xpm.

 -- LI Daobing <lidaobing@debian.org>  Thu, 23 Apr 2009 23:21:13 +0800

fcitx (1:3.4.99+svn163-0ubuntu1) jaunty; urgency=low

  * New upstream svn snapshot, upstream will release
    3.5 soon, so need more feedbacks.
  * Change Homepage to where the project is being hosted now.
  * Replace the old arphic fonts in Recommends.
  * Use QT_IM_MODULE=xim in im-switch conffile.

 -- Zhengpeng Hou <zhengpeng-hou@ubuntu.com>  Sun, 07 Dec 2008 12:30:20 +0000

fcitx (1:3.4.3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  [ LI Daobing ]
  * fix lintian error:
    - build-depends-on-obsolete-package build-depends: x-dev
    - declares-possibly-conflicting-debhelper-compat-versions rules=5 compat=5
  * fix im-switch conf file (Closes: #454363)
  [ Barry deFreese ]
  * Make clean not ignore errors.
  * Add copyright holders in debian/copyright.
  * Add watch file.
  * Add Homepage in source stanza.
  * Bump Standards Version to 3.8.0. (No changes needed).

 -- Barry deFreese <bdefreese@debian.org>  Wed, 19 Nov 2008 12:31:10 -0500

fcitx (1:3.4.3-1) unstable; urgency=medium

  * New upstream release
  * Fixed bad recommends fonts name. (Closes:Bug#379098) 
  * Fixed wubi crash. Thanks for Bin Tian's report and fix. (Closes:Bug#409999)

 -- Yu Guanghui <ygh@debian.org>  Wed,  7 Feb 2007 14:01:15 +0800

fcitx (1:3.4-1) unstable; urgency=low

  * New upstream release

 -- Yu Guanghui <ygh@debian.org>  Fri, 29 Sep 2006 22:12:32 +0800

fcitx (1:3.3.1-1) unstable; urgency=low

  * New upstream release

 -- Yu Guanghui <ygh@debian.org>  Thu, 14 Sep 2006 21:12:01 +0800

fcitx (1:3.2.1-1) unstable; urgency=low

  * New upstream release

 -- Yu Guanghui <ygh@debian.org>  Thu,  6 Jul 2006 01:13:46 +0800

fcitx (3.2.060108-3) unstable; urgency=low

  * Modify fcitx scrip for Qt/KDE  

 -- Yu Guanghui <ygh@debian.org>  Sun, 30 Apr 2006 13:40:34 +0800

fcitx (3.2.060108-2) unstable; urgency=low

  * Add missing dependency libxpm-dev. Closes: #364670 

 -- Yu Guanghui <ygh@debian.org>  Tue, 25 Apr 2006 12:20:52 +0800

fcitx (3.2.060108-1) unstable; urgency=high

  * New upstream release
  * Fixed RC bug. Closes: #357551
  * Add im-switch support. Thank Hou ZhengPeng <zhengpeng.hou@gmail.com>'s
    patch. Closes: #314743
  * Move Arphic fonts to Recommanded. Maybe it's time to packages other
    free chinese fonts. Closes: #293624

 -- Yu Guanghui <ygh@debian.org>  Mon, 24 Apr 2006 22:38:26 +0800

fcitx (3.1.1-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * High-urgency upload for RC bugfix.
  * Build-depend on libx11-dev, libxft-dev, and x-dev instead of on the
    obsolete xlibs-dev; thanks to Justin Pryzby <justinpryzby@users.sf.net>
    for testing.  Closes: #346744.
  * Re-run autoconf to pick up a version of AC_PATH_X that doesn't depend on
    libxt-dev.  Also add AM_MAINTAINER_MODE to configure.in, which seems to
    have been left out previously.

 -- Steve Langasek <vorlon@debian.org>  Fri, 20 Jan 2006 08:03:06 -0800

fcitx (3.1.1-1) unstable; urgency=low

  * New upstream release

 -- Yu Guanghui <ygh@debian.org>  Wed,  6 Apr 2005 16:30:47 +0800

fcitx (3.1-1) unstable; urgency=low

  * New upstream release

 -- Yu Guanghui <ygh@debian.org>  Wed, 23 Mar 2005 16:05:18 +0800

fcitx (3.0.3-1) unstable; urgency=low

  * New upstream release (Closes:Bug#285461)
  * Remove wrong installed file. (Closes:Bug#281718,Bug#284538)

 -- Yu Guanghui <ygh@debian.org>  Sun,  2 Jan 2005 13:50:18 +0800

fcitx (3.0.0-1) unstable; urgency=low

  * New upstream release (Closes:Bug#270422)

 -- Yu Guanghui <ygh@debian.org>  Tue, 7 Sep 2004 21:49:36 +0800

fcitx (2.0.2-3) unstable; urgency=low

  * Sorry, Oops. Forgot one, Fixed again. (Closes:Bug#250423)

 -- Yu Guanghui <ygh@debian.org>  Fri, 11 Jun 2004 01:58:36 +0800

fcitx (2.0.2-2) unstable; urgency=low

  * Fixed 64bit platforms error. Thanks Andreas Jochens <aj at 
    andaco.de>'s patch. (Closes:Bug#250423)

 -- Yu Guanghui <ygh@debian.org>  Thu, 10 Jun 2004 21:37:04 +0800

fcitx (2.0.2-1) unstable; urgency=low

  * New upstream release

 -- Yu Guanghui <ygh@debian.org>  Mon, 10 May 2004 11:14:08 +0800

fcitx (2.0.1-1) unstable; urgency=low

  * New upstream release

 -- Wang WenRui <wangwr@ustc.edu>  Fri,  9 Jan 2004 22:25:38 +0800

fcitx (2.0-1) unstable; urgency=low

  * New upstream release.

 -- Su Yong <yoyosu@ustc.edu.cn>  Thu,  8 Jan 2004 20:19:34 +0800



=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: Yu Guanghui <ygh@debian.org>
Uploaders: LI Daobing <lidaobing@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libx11-dev, libxft-dev, x11proto-core-dev,
 libxpm-dev, automake, autoconf, libxtst-dev
Standards-Version: 3.8.4
Homepage: http://code.google.com/p/fcitx/

Package: fcitx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: im-switch, ttf-arphic-uming | ttf-arphic-ukai
Description: Free Chinese Input Toy for X (XIM)
 fcitx is a simplified Chinese input server. It supports WuBi,
 Pinyin and QuWei input method. It's small and fast.

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/" \
http://code.google.com/p/fcitx/downloads/list \
http://fcitx.googlecode.com/files/fcitx-(.*)\.tar\.bz2

## fcitx 4.0.1

=== debian/changelog ===
fcitx (1:4.0.1-3) unstable; urgency=low

  * debian/control:
    + Add multiple Replaces/Breaks: fcitx (<< 1:4.0.0) (Closes: # 613022)
  * debian/patches/debian-ftbfs-609776.patch:
    + Really build on Hurd.

 -- Aron Xu <happyaron.xu@gmail.com>  Sat, 12 Feb 2011 19:03:26 +0800

fcitx (1:4.0.1-2) unstable; urgency=medium

  * debian/patches/debian-ftbfs-609776.patch:
    - Make it build on kfreebsd and hurd. (Closes: #609776)
  * debian/rules:
    - Run autoreconf becore dh_auto_configure, this is a temporary
      workaround bypassing the libtool error caused by patching
      configure{,in}, and will be removed in next upstream release.

 -- Aron Xu <happyaron.xu@gmail.com>  Fri, 14 Jan 2011 00:38:27 +0800

fcitx (1:4.0.1-1) unstable; urgency=low

  * New upstream release.
  * debian/control: 
    - Remove binutils-gold from build-dep, most archs doesn't have it.
    - Remove automake and autoconf from build-dep, not needed now.
    - Add DM-Upload-Allowed.
  * debian/patches/ :
    - Remove patches because upstream has applied them.
  * debian/rules:
    - Get back dh_auto_test.
    - Don't run autoreconf.
    - Pass parameter --enable-recording.
  * debian/fcitx.install and debian/fcitx.doc-base:
    - Remove fcitx4.pdf since removed from tarball by upstream.
  * debian/fcitx.doc-base:
    - Fix doc-base error by listing files in one line.

 -- Aron Xu <happyaron.xu@gmail.com>  Fri, 17 Dec 2010 18:56:00 +0800

fcitx (1:4.0.0-1) unstable; urgency=low

  * New upstream major release:
    - Get rid of unsafe environment variable usage. (Closes: #430420)
    - Create config file if not exist; Tray icon refresh background. 
      (Closes: #571588)
    - Use utf-8 config file with English options.
    - Fixe input problem in OpenOffice.org. (LP: #261382, LP: #238309)
  * debian/control:
    - Update to a new set of Build-Dep packages.
    - Improve descriptions.
    - Remove fonts from Recommends since fcitx can detect system font now.
      (Closes: #584307, LP: #482564)
    - Split package into 12. 
    - Use binutils-gold.
  * debian/rules: 
    - Set LDFLAGS="-Wl,--as-needed".
  * debian/Makefile, debian/Makefile.am, debian/Makefile.in,
    source.lintian-overrides, README, README.Debian: Remove.
  * debian/copyright: Rewrite.
  * debian/patches/binutils-gold.patch: 
    - Remove, for upstream has accepted it.
  * debian/patches/1ca5ac8c5b.patch:
    - Fix desc.po problem and do not distclean tarball files.
      (Backport from upstream 1ca5ac8c5b commit.)
  * debian/docs: Install upstream textual files.
  * debian/clean: Clean autoreconf generated files.
  * debian/fcitx.doc-base, debian/fcitx-table-wubi.doc-base: 
    - Add doc-base entries.

 -- Aron Xu <happyaron.xu@gmail.com>  Fri, 25 Nov 2010 21:33:23 +0800

fcitx (1:3.6.4-1) unstable; urgency=low

  [ Aron Xu ]
  * New upstream release:
    - Change data/pyPhrase.py to avoid copyright problem.
  * Change Maintainer field to IME Packaging Team, move original
    maintainer to Uploaders, add myself to Uploaders.
  * debian/rules:
    - Update to use upstream autogen.sh, since autoreconf isn't enough now.
  * debian/fcitx.doc-base.EX: Removed, will add back in 4.0.0 release.
  * debian/source.lintian-overrides: Removed.

  [ LI Daobing ]
  * debian/watch: updated.
  * debian/control:
    - add Vcs-* fields.
    - add wqy fonts to depends (Closes: #584307)
    - bump standards version to 3.9.1.

 -- Aron Xu <happyaron.xu@gmail.com>  Fri, 19 Nov 2010 14:44:31 +0800

=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: LI Daobing <lidaobing@debian.org>, Aron Xu <happyaron.xu@gmail.com>, Yu Guanghui <ygh@debian.org>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), libpango1.0-dev, libcairo2-dev, libdbus-1-dev, intltool (>= 0.35.0), libtool
Standards-Version: 3.9.1
Homepage: http://code.google.com/p/fcitx/
Vcs-Bzr: lp:~pkg-ime/fcitx/debian-fcitx
Vcs-Browser: https://code.launchpad.net/~pkg-ime/fcitx/debian-fcitx

Package: fcitx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-data
Recommends: im-switch, fcitx-config-gtk
Suggests: fcitx-table-all, fcitx-tools
Description: Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 It supports Pinyin, QuWei and Table-based input methods. 

Package: fcitx-data
Architecture: all
Depends: ${misc:Depends}
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Data files of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains essential data files of fcitx.

Package: fcitx-table-all
Architecture: all
Depends: ${misc:Depends}, fcitx-table-bingchan, fcitx-table-cangjie, fcitx-table-dianbaoma, fcitx-table-erbi, fcitx-table-wanfeng, fcitx-table-wbpy, fcitx-table-wubi, fcitx-table-ziranma
Description: Tables of Free Chinese Input Toy for X (XIM) - meta package
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package pulls in following tables (and configs) for fcitx:
  * Cangjie
  * Dianbaoma
  * Erbi
  * Bingchan
  * Wanfeng
  * WubiPinyin
  * Wubi
  * Ziranma

Package: fcitx-table-bingchan
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Bingchan table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Bingchan table and config for fcitx.

Package: fcitx-table-cangjie
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Cangjie table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Cangjie table and config for fcitx.

Package: fcitx-table-dianbaoma
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Dianbaoma table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Dianbaoma table and config for fcitx.

Package: fcitx-table-erbi
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Erbi table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Erbi table and config for fcitx.

Package: fcitx-table-wanfeng
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Wanfeng table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Wanfeng table and config for fcitx.

Package: fcitx-table-wbpy
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Wubi-pinyin table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Wubi-pinyin table and config for fcitx.

Package: fcitx-table-wubi
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Wubi table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Wubi table and config for fcitx.

Package: fcitx-table-ziranma
Architecture: all
Depends: ${misc:Depends}, fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Ziranma table of Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains Ziranma table and config for fcitx.

Package: fcitx-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx
Replaces: fcitx (<< 1:4.0.0)
Breaks: fcitx (<< 1:4.0.0)
Description: Tools for Free Chinese Input Toy for X (XIM)
 fcitx is a small and fast input server initially designed for Chinese, 
 which is also useful for some other languages (especially CJK) now. 
 .
 This package contains following tools for fcitx:
  * createPYMB
  * mb2org
  * mb2txt
  * readPYBase
  * readPYMB
  * scel2org
  * txt2mb

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS=-Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	./autogen.sh
	dh_auto_configure -- --enable-recording

=== debian/watch ===
version=3
http://googlecode.debian.net/p/fcitx/fcitx-(\d+.*)\.tar\.gz
